<template>
  <v-app class="performingTreatment">
    <div class="performingTreatment__title">
      <h1>Выполнение лечения</h1>
    </div>

    <!--Поиск-->
    <v-text-field class="performingTreatment__search" v-model="search" append-icon="mdi-magnify" label="Поиск.."
                  single-line
                  hide-details></v-text-field>

    <v-container class="performingTreatment__buttons">
      <v-row>
        <v-dialog v-model="dialogDrug" max-width="500">

          <template v-slot:activator="{ on, attrs }">
            <v-btn color="primary" class="performingTreatment__btn" v-bind="attrs" v-on="on" @click="loadPageDrug">
              Выполнить лечение по лекарствам
            </v-btn>
          </template>

          <v-card>
            <v-card-text>
              <v-container>
                <v-col cols="12" sm="6" md="6">
                  <v-overflow-btn v-model="editedItemDrug.medicalCardId" :items="medicalCards" item-value="id"
                                  :item-text="item => item.name +' ' + item.surname + ' ' + item.fatherName"
                                  label="Медкарта" @change="fetchDrug(editedItemDrug)"/>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field v-model="editedItemDrug.dateStart" label="Дата лечения" placeholder="YYYY-MM-DD"/>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-overflow-btn v-model="editedItemDrug.drugId" :items="drugByPatient" item-value="id"
                                  item-text="drug.name"
                                  label="Лекарства"/>
                </v-col>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="close">Закрыть</v-btn>
              <v-btn color="blue darken-1" text @click="saveDrug">Сохранить</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>

      <v-row>
        <v-dialog v-model="dialogService" max-width="500">
          <template v-slot:activator="{ on, attrs }">
            <v-btn color="primary" class="performingTreatment__btn" v-bind="attrs" v-on="on" @click="loadPageService">
              Выполнить лечение по услугам
            </v-btn>
          </template>
          <v-card>
            <v-card-text>
              <v-container>
                <v-col cols="12" sm="6" md="6">
                  <v-overflow-btn v-model="editedItemService.medicalCardId" :items="medicalCards" item-value="id"
                                  :item-text="item => item.name +' ' +item.surname+' '+item.fatherName"
                                  label="Медкарта" @change="fetchService(editedItemService)"/>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-text-field v-model="editedItemService.dateStart" label="Дата лечения" placeholder="YYYY-MM-DD"/>
                </v-col>
                <v-col cols="12" sm="6" md="6">
                  <v-overflow-btn v-model="editedItemService.serviceId" :items="serviceByPatient" item-value="id"
                                  item-text="service.name"
                                  label="Услуга"/>
                </v-col>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="close">Закрыть</v-btn>
              <v-btn color="blue darken-1" text @click="saveService">Сохранить</v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-row>
    </v-container>

    <v-container class="performingTreatment__tables">
      <v-data-table
          :headers="headersDrug"
          :items="prescribedDrugs"
          :search="search"
          class="performingTreatment__table_1"
          sort-by="id"
      >
        <template #item.patientFullName="{ item }">{{ item.dailyStatus.medicalCard.patient.surname }}
          {{ item.dailyStatus.medicalCard.patient.name }} {{ item.dailyStatus.medicalCard.patient.fatherName }}
        </template>
        <template #item.doctorFullName="{ item }">{{ item.dailyStatus.medicalCard.medication.user.surname }}
          {{ item.dailyStatus.medicalCard.medication.user.name }}
          {{ item.dailyStatus.medicalCard.medication.user.fatherName }}
        </template>
      </v-data-table>

      <v-data-table
          :headers="headersService"
          :items="prescribedServices"
          :search="search"
          class="performingTreatment__table_2"
          sort-by="id"
      >
        <template #item.patientFullName="{ item }">{{ item.dailyStatus.medicalCard.patient.surname }}
          {{ item.dailyStatus.medicalCard.patient.name }} {{ item.dailyStatus.medicalCard.patient.fatherName }}
        </template>
        <template #item.doctorFullName="{ item }">{{ item.dailyStatus.medicalCard.medication.user.surname }}
          {{ item.dailyStatus.medicalCard.medication.user.name }}
          {{ item.dailyStatus.medicalCard.medication.user.fatherName }}
        </template>
      </v-data-table>
    </v-container>
  </v-app>
</template>

<script>
import axios from "axios";

export default {
  name: "PerformingTreatment",
  data() {
    return {
      prescribedDrugs: [],
      prescribedServices: [],
      medicalCards: [],
      services: [],
      drugs: [],
      drugByPatient: [],
      medicalCardsNames: [],
      medicalCardById: [],
      serviceByPatient: [],
      search: '',
      dialogDrug: false,
      dialogService: false,

      editedItemDrug: [
        {
          medicalCardId: '',
          dateStart: 'YYYY-MM-DD',
          drugId: ''
        }
      ],

      editedItemService: [
        {
          medicalCardId: '',
          dateStart: 'YYYY-MM-DD',
          serviceId: ''
        }
      ],

      headersService: [
        {
          text: 'Пациент',
          value: 'patientFullName',
          sortable: false
        },
        {
          text: 'День',
          value: 'dailyStatus.date',
          sortable: false
        },
        {
          text: 'Услуга',
          value: 'medicationService.service.name',
          sortable: false
        },
        {
          text: 'Количество',
          value: 'medicationService.count',
          sortable: false,
        },
        {
          text: 'Врач',
          value: 'doctorFullName',
          sortable: false,
        },
      ],

      headersDrug: [
        {
          text: 'Пациент',
          value: 'patientFullName',
          sortable: false
        },
        {
          text: 'День',
          value: 'dailyStatus.date',
          sortable: false
        },
        {
          text: 'Лекарство',
          value: 'receipt.drug.name',
          sortable: false
        },
        {
          text: 'Количество',
          value: 'receipt.count',
          sortable: false,
        },
        {
          text: 'Врач',
          value: 'doctorFullName',
          sortable: false,
        },
      ]
    }
  },

  mounted() {
    this.fetchPerformingTreatment()
  },

  methods: {
    async fetchPerformingTreatment() {
      axios
          .get(this.$root.globalVar + '/daily_status_medication_service')
          .then(response => {
            this.prescribedServices = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/daily_status_receipt')
          .then(response => {
            this.prescribedDrugs = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })

      axios
          .get(this.$root.globalVar + '/medical_card')
          .then(response => {
            this.medicalCardsNames = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchDrug(id) {
      const medicalCard = await this.fetchMedicalCard(id.medicalCardId)
      axios
          .get(this.$root.globalVar + '/receipt/patient/' + medicalCard.patient.id)
          .then(response => {
            this.drugByPatient = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchService(id) {
      const medicalCard = await this.fetchMedicalCard(id.medicalCardId)
      axios
          .get(this.$root.globalVar + '/medication_service/patient/' + medicalCard.patient.id)
          .then(response => {
            this.serviceByPatient = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    async fetchMedicalCard(id) {
      let data
      await axios
          .get(this.$root.globalVar + '/medical_card/' + id)
          .then(response => {
            data = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
            return null
          })
      return data
    },

    async fetchCheckDailyStatus(item) {
      console.log('item ', item)
      let data
      await axios.post(this.$root.globalVar + '/daily_status/check', {
        medicalCardId: item.medicalCardId,
        date: item.dateStart
      })
          .then(response => {
            data = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
      return data
    },

    async fetchPerformingDrug() {
      const dailyStatus = await this.fetchCheckDailyStatus(this.editedItemDrug)
      axios.post(this.$root.globalVar + '/daily_status_receipt', {
        dailyStatusId: dailyStatus.id,
        receiptId: this.editedItemDrug.drugId
      })
          .then(response => {
            this.prescribedDrugs.push(response.data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    async fetchPerformingService() {
      const dailyStatus = await this.fetchCheckDailyStatus(this.editedItemService)
      axios.post(this.$root.globalVar + '/daily_status_medication_service', {
        dailyStatusId: dailyStatus.id,
        medicationServiceId: this.editedItemService.serviceId
      })
          .then(response => {
            this.prescribedServices.push(response.data)
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    loadPageDrug() {
      this.medicalCardsNames.forEach(medicalCard => this.medicalCards.push(medicalCard.patient))
    },

    loadPageService() {
      this.medicalCardsNames.forEach(medicalCard => this.medicalCards.push(medicalCard.patient))
    },

    close() {
      this.dialogDrug = false
      this.dialogService = false
    },

    saveDrug() {
      if (this.editedItemDrug.medicalCardId === '' || this.editedItemDrug.dateStart === '' || this.editedItemDrug.drugId === '') {
        alert('Ошибка! Подробности: введите данные.')
        throw new Error("Ошибка! Подробности: введите данные.");
      }
      else {
        this.fetchPerformingDrug()
        this.close()
      }
    },

    saveService() {
      if (this.editedItemDrug.medicalCardId === '' || this.editedItemDrug.dateStart === '' || this.editedItemDrug.serviceId === '') {
        alert('Ошибка! Подробности: введите данные.')
        throw new Error("Ошибка! Подробности: введите данные.");
      }
      else {
        this.fetchPerformingService()
        this.close()
      }
    }
  }
}
</script>

<style lang="scss" scoped>
.performingTreatment {
  &__title {
    margin: 60px 0 30px 0;
    text-align: center;
  }

  &__search {
    width: 50%;
    margin: 0 auto;
  }

  &__table_1, &__table_2 {
    width: 50%;
    margin: 0 auto;
  }

  &__table_1 {
    margin-right: 50px;
  }

  &__tables {
    display: flex;
  }

  &__buttons {
    display: flex;
  }
}

.v-text-field {
  flex: 0.3 0 !important;
  margin-top: 30px;
}

.row {
  display: flex;
  justify-content: right !important;
  margin: 0 40px 30px 0;
}
</style>